﻿XIncludeFile "eval_inc.pb"

UsePNGImageDecoder()

Declare.l IAbs(w.l)
Declare Init()
Declare SetLevel(nn.l, mm.l)
Declare SetOption(nn.l, mm.l)
Declare.l ImgNum(ii.l, jj.l)
Declare.s MoveString(nn)
Declare Timer()
Declare.l Back()
Declare.l Replay()
Declare MakeMove()
Declare.l ValidMoves(ii.l, jj.l, rr.l)
Declare.l AllValidMoves(cc.l, rr.l)
Declare.l PreMill(cc.l, rr.l)
Declare.b IsMill(ii.l, jj.l, rr.l)
Declare.b CanRemove(nn.l, mm.l, rr.l)
Declare.l MakeVirtualMove(ii0.l, jj0.l, ii1.l, jj1.l, rr.l)
Declare.l VirtualRemove(ii0.l, jj0.l, ii1.l, jj1.l, rr.l)
Declare.l MakeBestMove(nn.l, ll.l, vv_cut.l)
Declare.l Clicked(ii.l, jj.l)
Declare.l GetGameX(gx.l, gy.l)
Declare.l GetGameY(gx.l, gy.l)
Declare RefreshScreen()
Declare BoardEventHandler(x, y, EventType)
Declare SetStartOptions()
Declare GetStartOptions()
Declare DrawBoard()
Declare RefreshBoard()

Global MuehleGUI

Global ende.b = #False

Global Frame_0, White1, White2, Frame_1, Text_0, WhiteLevel1, WhiteLevel2, WhiteLevel3, Frame_2, Black1, Black2, Frame_3, Text_1, BlackLevel1, BlackLevel2, BlackLevel3, Frame_4, Start1, Start2, Frame_5, Msg, NewButton, DBack, OBack, Moves, OForward, DForward, Spielbrett

Global i.l, j.l, best_i.l, best_j.l, IsOver.b = #True, Start.l, NextStart.l = 0, LastEvent.s = ""
Global NeedToMove, NeedToRemove, MoveCount, MaxMoveCount, MaxMove = 1000

Global Dim I_Sel.l(3)
Global Dim J_Sel.l(3)
Global Dim NumPieces.l(1, 2)
Global Dim Level.l(1)
Level(0) = 1
Level(1) = 2
Global Dim IsPlayer.l(1)
IsPlayer(0) = #True
IsPlayer(1) = #False
Global Dim Fld.l(4, 8, 2)
Global Dim Pic.l(5)
Global Dim History.l(1, MaxMove+18)

;Bilder als Resource
Pic(0) = CatchImage(#PB_Any, ?mill0)
Pic(1) = CatchImage(#PB_Any, ?mill1)
Pic(2) = CatchImage(#PB_Any, ?mill2)
Pic(3) = CatchImage(#PB_Any, ?mill3)
Pic(4) = CatchImage(#PB_Any, ?mill4)
Pic(5) = CatchImage(#PB_Any, ?millbg)

Procedure.l IAbs(w.l)
  tw.f = ValF(Str(w))
  tw2.f = Abs(tw)
  ProcedureReturn Val(StrF(tw2))
EndProcedure

Procedure Init()
  ii.l : jj.l
  For ii = 0 To 2
    For jj = 0 To 8
      Fld(ii, jj, 0) = -1
    Next jj
  Next ii
  For ii = 3 To 4
    For jj = 0 To 8
      Fld(ii, jj, 0) = ii-3
    Next jj
  Next ii
  For ii = 0 To 3
    I_Sel(ii) = -1
    J_Sel(ii) = -1
  Next ii
  Start = NextStart
  LastEvent = ""
  NumPieces(0, 0) = 9
  NumPieces(1, 0) = 9
  MoveCount = 0
  MaxMoveCount = 0
  NeedToMove = 0
  NeedToRemove = #False
  RefreshScreen()
  IsOver = #False
EndProcedure

Procedure SetLevel(nn.l, mm.l)
  Level(nn) = mm
EndProcedure

Procedure SetOption(nn.l, mm.l)
  If nn < 2
    IsPlayer(nn) = mm
  Else
    NextStart = 1-mm
  EndIf
EndProcedure

Procedure.l ImgNum(ii.l, jj.l)
  cc.l = 33
  If ii < 3
    If jj = 0
      ProcedureReturn (cc-(ii+1)*7)
    EndIf
    If jj = 1
      ProcedureReturn (cc-(ii+1)*7+(ii+1))
    EndIf
    If jj = 2
      ProcedureReturn (cc+(ii+1))
    EndIf
    If jj = 3
      ProcedureReturn (cc+(ii+1)*7+(ii+1))
    EndIf
    If jj = 4
      ProcedureReturn (cc+(ii+1)*7)
    EndIf
    If jj = 5
      ProcedureReturn (cc+(ii+1)*7-(ii+1))
    EndIf
    If jj = 6
      ProcedureReturn (cc-(ii+1))
    EndIf
    If jj = 7
      ProcedureReturn (cc-(ii+1)*7-(ii+1))
    EndIf
  EndIf
  If ii = 3
    ProcedureReturn jj
  EndIf
  If ii = 4
    ProcedureReturn (jj+58)
  EndIf
  ProcedureReturn 0
EndProcedure

Procedure.s MoveString(nn)
  If nn >= 100
    ProcedureReturn eval(Str(nn))
  EndIf
  If nn >= 10
    ProcedureReturn " "+eval(Str(nn))+" "
  EndIf
  ProcedureReturn " "+eval(Str(nn))+" "
EndProcedure

Procedure Timer()
  If IsOver
    ProcedureReturn 0
  EndIf
  If ((NeedToMove = 0) And (Not NeedToRemove))
    If (Not IsPlayer((MoveCount+Start)%2))
      If LastEvent = ""
        MakeBestMove(0, Level((MoveCount+Start)%2), 31000)
      EndIf
      If LastEvent = "Back"
        Back()
        LastEvent = ""
      EndIf
      If LastEvent = "Replay"
        Replay()
        LastEvent = ""
      EndIf
    EndIf
  EndIf
  If NeedToMove > 0
    If NeedToMove = 6
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+3)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
        StopDrawing()
      EndIf
    EndIf
    If NeedToMove = 5
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+3)),GetGameX(I_Sel(1), J_Sel(1)), GetGameY(I_Sel(1), J_Sel(1)))
        DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
        StopDrawing()
      EndIf
    EndIf
    If NeedToMove = 4
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+1)),GetGameX(I_Sel(1), J_Sel(1)), GetGameY(I_Sel(1), J_Sel(1)))
        StopDrawing()
      EndIf
    EndIf
    If NeedToMove = 3
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+3)),GetGameX(I_Sel(2), J_Sel(2)), GetGameY(I_Sel(2), J_Sel(2)))
        StopDrawing()
      EndIf
    EndIf
    If NeedToMove = 2
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+3)),GetGameX(I_Sel(3), J_Sel(3)), GetGameY(I_Sel(3), J_Sel(3)))
        DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(2), J_Sel(2)), GetGameY(I_Sel(2), J_Sel(2)))
        StopDrawing()
      EndIf
    EndIf
    If NeedToMove = 1
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+1)),GetGameX(I_Sel(3), J_Sel(3)), GetGameY(I_Sel(3), J_Sel(3)))
        StopDrawing()
      EndIf
    EndIf
    NeedToMove = NeedToMove - 1
    If ((NeedToMove = 3) And (Not NeedToRemove))
      NeedToMove = 0
    EndIf
    If NeedToMove = 0
      SetGadgetText(Moves, MoveString(MoveCount+1))
      MakeMove()
      If IsOver
        SetGadgetText(Msg, " ")
      Else
        If ((MoveCount+Start)%2 = 0)
          SetGadgetText(Msg, " Weiß am Zug.")
        Else
          SetGadgetText(Msg, " Schwarz am Zug")
        EndIf
      EndIf
    EndIf
  EndIf
EndProcedure

Procedure.l Back()
  hh.l : ii0.l : ii1.l : jj0.l : jj1.l
  If NeedToMove <> 0
    LastEvent = "Back"
    ProcedureReturn 0
  EndIf
  If MoveCount = 0
    ProcedureReturn 0
  EndIf
  IsOver = #False
  MoveCount = MoveCount - 1
  hh = History(0, MoveCount)
  jj1 = hh%10 : hh = (hh-jj1)/10
  ii1 = hh%10 : hh = (hh-ii1)/10
  jj0 = hh%10 : hh = (hh-jj0)/10
  ii0 = hh%10
  Fld(ii0, jj0, 0) = Fld(ii1, jj1, 0)
  Fld(ii1, jj1, 0) = -1
  If StartDrawing(CanvasOutput(Spielbrett))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawAlphaImage(ImageID(Pic(Fld(ii0, jj0, 0)+1)),GetGameX(ii0, jj0), GetGameY(ii0, jj0))
    DrawAlphaImage(ImageID(Pic(Fld(ii1, jj1, 0)+1)),GetGameX(ii1, jj1), GetGameY(ii1, jj1))
    StopDrawing()
  EndIf
  hh = History(1, MoveCount)
  If (hh > 0)
    jj1 = hh%10 : hh = (hh-jj1)/10
    ii1 = hh%10 : hh = (hh-ii1)/10
    jj0 = hh%10 : hh = (hh-jj0)/10
    ii0 = hh%10
    Fld(ii0, jj0, 0) = Fld(ii1, jj1, 0)
    Fld(ii1, jj1, 0) = -1
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(Fld(ii0, jj0, 0)+1)),GetGameX(ii0, jj0), GetGameY(ii0, jj0))
      DrawAlphaImage(ImageID(Pic(Fld(ii1, jj1, 0)+1)),GetGameX(ii1, jj1), GetGameY(ii1, jj1))
      StopDrawing()
    EndIf
    NumPieces((MoveCount+Start+1)%2, 0) = NumPieces((MoveCount+Start+1)%2, 0) + 1
  EndIf
  SetGadgetText(Moves, MoveString(MoveCount))
  If ((MoveCount+Start)%2 = 0)
    SetGadgetText(Msg, " Weiß am Zug.")
  Else
    SetGadgetText(Msg, " Schwarz am Zug.")
  EndIf
EndProcedure

Procedure.l Replay()
  hh.l
  If NeedToMove <> 0
    LastEvent = "Replay"
    ProcedureReturn 0
  EndIf
  If MoveCount = MaxMoveCount
    ProcedureReturn 0
  EndIf
  hh = History(0, MoveCount)
  J_Sel(1) = hh%10 : hh = (hh-J_Sel(1))/10
  I_Sel(1) = hh%10 : hh = (hh-I_Sel(1))/10
  J_Sel(0) = hh%10 : hh = (hh-J_Sel(0))/10
  I_Sel(0) = hh%10
  If StartDrawing(CanvasOutput(Spielbrett))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+1)),GetGameX(I_Sel(1), J_Sel(1)), GetGameY(I_Sel(1), J_Sel(1)))
    DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
    StopDrawing()
  EndIf
  hh = History(0, MoveCount)
  If (hh > 0)
    J_Sel(3) = hh%10 : hh = (hh-J_Sel(3))/10
    I_Sel(3) = hh%10 : hh = (hh-I_Sel(3))/10
    J_Sel(2) = hh%10 : hh = (hh-J_Sel(2))/10
    I_Sel(2) = hh%10
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+1)),GetGameX(I_Sel(3), J_Sel(3)), GetGameY(I_Sel(3), J_Sel(3)))
      DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(2), J_Sel(2)))
      StopDrawing()
    EndIf
    NeedToRemove = #True
  Else
    NeedToRemove = #False
  EndIf
  SetGadgetText(Moves, MoveString(MoveCount+1))
  MakeMove()
  If IsOver
    SetGadgetText(Msg, " ")
  Else
    If ((MoveCount+Start)%2 = 0)
      SetGadgetText(Msg, " Weiß am Zug.")
    Else
      SetGadgetText(Msg, " Schwarz am Zug.")
    EndIf
  EndIf
EndProcedure

Procedure MakeMove()
  hh.l
  Fld(I_Sel(1), J_Sel(1), 0) = Fld(I_Sel(0), J_Sel(0), 0)
  Fld(I_Sel(0), J_Sel(0), 0) = -1
  hh = I_Sel(0)*1000+J_Sel(0)*100+I_Sel(1)*10+J_Sel(1)
  If (History(0, MoveCount) <> hh)
    History(0, MoveCount) = hh
    MaxMoveCount = MoveCount+1
  EndIf
  If NeedToRemove
    Fld(I_Sel(3), J_Sel(3), 0) = Fld(I_Sel(2), J_Sel(2), 0)
    Fld(I_Sel(2), J_Sel(2), 0) = -1
    hh = I_Sel(2)*1000+J_Sel(2)*100+I_Sel(3)*10+J_Sel(3)
    If (History(1, MoveCount) <> hh)
      History(1, MoveCount) = hh
      MaxMoveCount = MoveCount+1
    EndIf
    NumPieces((MoveCount+Start+1)%2, 0) = NumPieces((MoveCount+Start+1)%2, 0) - 1
    If (NumPieces((MoveCount+Start+1)%2, 0) < 3)
      If ((MoveCount+Start)%2 = 0)
        MessageRequester("Spielende", "Weiß hat gewonnen!")
      Else
        MessageRequester("Spielende", "Schwarz hat gewonnen!")
      EndIf
      IsOver = #True
    EndIf
  Else
    History(1, MoveCount) = 0
  EndIf
  NeedToRemove = #False
  If ((MoveCount >= 17) And (NumPieces((MoveCount+Start+1)%2, 0) > 3))
    If (AllValidMoves((MoveCount+Start+1)%2, 0) = 0)
      If ((MoveCount+Start)%2 = 0)
        MessageRequester("Spielende", "Weiß hat gewonnen!")
      Else
        MessageRequester("Spielende", "Schwarz hat gewonnen!")
      EndIf
      IsOver = #True
    EndIf
  EndIf
  MoveCount = MoveCount + 1
  If MaxMoveCount < MoveCount
    MaxMoveCount = MoveCount
  EndIf
  If MoveCount = MaxMove
    MessageRequester("Spielende", "Unentschieden!")
    IsOver = #True
  EndIf
EndProcedure

Procedure.l ValidMoves(ii.l, jj.l, rr.l)
  nn.l = 0
  If (jj%2 = 0)
    If ii = 1
      If (Fld(0, jj, rr) = -1)
        nn = nn + 1
      EndIf
      If (Fld(2, jj, rr) = -1)
        nn = nn + 1
      EndIf
    Else
      If (Fld(1, jj, rr) = -1)
        nn = nn + 1
      EndIf
    EndIf
  EndIf
  If (Fld(ii, (jj+1)%8, rr) = -1)
    nn = nn + 1
  EndIf
  If (Fld(ii, (jj+7)%8, rr) = -1)
    nn = nn + 1
  EndIf
  ProcedureReturn nn
EndProcedure

Procedure.l AllValidMoves(cc.l, rr.l)
  ii.l : jj.l : nn.l = 0
  For ii = 0 To 2
    For jj = 0 To 7
      If (Fld(ii, jj, rr) = cc)
        nn = nn + ValidMoves(ii, jj, rr)
      EndIf
    Next jj
  Next ii
  ProcedureReturn nn
EndProcedure

Procedure.l PreMill(cc.l, rr.l)
  ii.l : jj.l : nn.l = 0
  For ii = 0 To 2
    For jj = 0 To 7
      If (Fld(ii, jj, rr) = -1)
        Fld(ii, jj, rr) = cc
        If IsMill(ii, jj, rr)
          nn = nn + 1
        EndIf
        Fld(ii, jj, rr) = -1
      EndIf
    Next jj
  Next ii
  ProcedureReturn nn
EndProcedure

Procedure.b IsMill(ii.l, jj.l, rr.l)
  If (jj%2 = 0)
    If ((Fld(0, jj, rr) = Fld(1, jj, rr)) And (Fld(0, jj, rr) = Fld(2, jj, rr)))
      ProcedureReturn #True
    EndIf
  EndIf
  If ((jj = 7) Or (jj = 0) Or (jj = 1))
    If ((Fld(ii, 7, rr) = Fld(ii, 0, rr)) And (Fld(ii, 7, rr) = Fld(ii, 1, rr)))
      ProcedureReturn #True
    EndIf
  EndIf
  If ((jj = 1) Or (jj = 2) Or (jj = 3))
    If ((Fld(ii, 1, rr) = Fld(ii, 2, rr)) And (Fld(ii, 1, rr) = Fld(ii, 3, rr)))
      ProcedureReturn #True
    EndIf
  EndIf
  If ((jj = 3) Or (jj = 4) Or (jj = 5))
    If ((Fld(ii, 3, rr) = Fld(ii, 4, rr)) And (Fld(ii, 3, rr) = Fld(ii, 5, rr)))
      ProcedureReturn #True
    EndIf
  EndIf
  If ((jj = 5) Or (jj = 6) Or (jj = 7))
    If ((Fld(ii, 5, rr) = Fld(ii, 6, rr)) And (Fld(ii, 5, rr) = Fld(ii, 7, rr)))
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.b CanRemove(nn.l, mm.l, rr.l)
  ii.l : jj.l : cc.l = Fld(nn, mm, rr)
  If (Not IsMill(nn, mm, rr))
    ProcedureReturn #True
  EndIf
  For ii = 0 To 2
    For jj = 0 To 7
      If (Fld(ii, jj, rr) = cc)
        If (Not IsMill(ii, jj, rr))
          ProcedureReturn #False
        EndIf
      EndIf
    Next jj
  Next ii
  ProcedureReturn #True
EndProcedure

Procedure.l MakeVirtualMove(ii0.l, jj0.l, ii1.l, jj1.l, rr.l)
  ii.l : jj.l
  If ((ii1 < 0) Or (ii1 > 2))
    ProcedureReturn 0
  EndIf
  If (Fld(ii1, jj1, rr-1) <> -1)
    ProcedureReturn 0
  EndIf
  For ii = 0 To 4
    For jj = 0 To 8
      Fld(ii, jj, rr) = Fld(ii, jj, rr-1)
    Next jj
  Next ii
  NumPieces(0, rr) = NumPieces(0, rr-1)
  NumPieces(1, rr) = NumPieces(1, rr-1)
  Fld(ii1, jj1, rr) = Fld(ii0, jj0, rr)
  Fld(ii0, jj0, rr) = -1
  If (Not IsMill(ii1, jj1, rr))
    ProcedureReturn 1
  EndIf
  NumPieces((MoveCount+Start+1)%2, rr) = NumPieces((MoveCount+Start+1)%2, rr) - 1
  ProcedureReturn 2
EndProcedure

Procedure.l VirtualRemove(ii0.l, jj0.l, ii1.l, jj1.l, rr.l)
  ii.l : jj.l
  If (Fld(ii0, jj0, rr) <> (MoveCount+Start+1)%2)
    ProcedureReturn 0
  EndIf
  If (Not CanRemove(ii0, jj0, rr))
    ProcedureReturn 0
  EndIf
  Fld(ii1, jj1, rr) = Fld(ii0, jj0, rr)
  Fld(ii0, jj0, rr) = -1
  ProcedureReturn 1
EndProcedure

Procedure.l MakeBestMove(nn.l, ll.l, vv_cut.l)
  #RandMax = 2147483647 ;Random()-Zahl
  rand.f = 0.0
  ii0.l : jj0.l : ii1.l : jj1.l : ii2.l : jj2.l : ii3.l : jj3.l : rr.l = nn + 1
  vv.l : dd.l : act_val.l : best_val.l = -30000
  mm.l = (MoveCount+Start)%2 : mm1.l = 1-mm : zz.l
  If nn = ll
    act_val = 200*(NumPieces(mm, nn) - NumPieces(mm1, nn))
    If ll < 3
      If MoveCount < 16
        act_val = act_val + (20*PreMill(mm, nn))
        act_val = act_val - (15*PreMill(mm1, nn))
      Else
        If NumPieces(mm, nn) = 3
          act_val = act_val + (40*PreMill(mm, nn))
          act_val = act_val - (30*PreMill(mm1, nn))
        EndIf
      EndIf
    EndIf
    If NumPieces(mm, nn) = 3
      ProcedureReturn act_val
    EndIf
    act_val = act_val + (5*AllValidMoves(mm, nn))
    act_val = act_val - (3*AllValidMoves(mm1, nn))
    ProcedureReturn act_val
  EndIf
  If (MoveCount < 18)
    ii0 = mm+3
    jj0 = 0
    While (Fld(ii0, jj0, nn) <> mm)
      jj0 = jj0 + 1
    Wend
    For ii1 = 0 To 2
      For jj1 = 0 To 7
        vv = MakeVirtualMove(ii0, jj0, ii1, jj1, rr)
        If (vv > 0)
          ;isvalid = #True
          If vv = 1
            MoveCount = MoveCount + 1
            zz = 0
            If rr = 1
              rand = Random(#RandMax)/#RandMax
              zz = Round(rand*3*(4-ll), #PB_Round_Down)
            EndIf
            act_val = zz - MakeBestMove(rr, ll, zz-best_val)
            MoveCount = MoveCount - 1
            If act_val >= vv_cut
              ProcedureReturn act_val
            EndIf
            If best_val < act_val
              best_val = act_val
              If rr = 1
                I_Sel(0) = ii0
                J_Sel(0) = jj0
                I_Sel(1) = ii1
                J_Sel(1) = jj1
                NeedToRemove = #False
              EndIf
            EndIf
          Else
            ii3 = mm+3
            jj3 = 0
            While (Fld(ii3, jj3, rr) <> -1)
              jj3 = jj3 + 1
            Wend
            For ii2 = 0 To 2
              For jj2 = 0 To 7
                If (VirtualRemove(ii2, jj2, ii3, jj3, rr) > 0)
                  MoveCount = MoveCount + 1
                  zz = 0
                  If rr = 1
                    rand = Random(#RandMax)/#RandMax
                    zz = Round(rand*6*(4-ll), #PB_Round_Down)
                  EndIf
                  act_val = zz - MakeBestMove(rr, ll, zz-best_val)
                  MoveCount = MoveCount - 1
                  If act_val >= vv_cut
                    ProcedureReturn act_val
                  EndIf
                  If best_val < act_val
                    best_val = act_val
                    If rr = 1
                      I_Sel(0) = ii0
                      J_Sel(0) = jj0
                      I_Sel(1) = ii1
                      J_Sel(1) = jj1
                      I_Sel(2) = ii2
                      J_Sel(2) = jj2
                      I_Sel(3) = ii3
                      J_Sel(3) = jj3
                      NeedToRemove = #True
                    EndIf
                  EndIf
                  Fld(ii2, jj2, rr) = Fld(ii3, jj3, rr)
                  Fld(ii3, jj3, rr) = -1
                EndIf
              Next jj2
            Next ii2
          EndIf
        EndIf
      Next jj1
    Next ii1
  Else
    If (NumPieces(mm, nn) = 3)
      For ii0 = 0 To 2
        For jj0 = 0 To 7
          If Fld(ii0, jj0, nn) = mm
            For ii1 = 0 To 2
              For jj1 = 0 To 7
                vv = MakeVirtualMove(ii0, jj0, ii1, jj1, rr)
                If (vv > 0)
                  ;isvalid = #True
                  If vv = 1
                    MoveCount = MoveCount + 1
                    zz = 0
                    If rr = 1
                      rand = Random(#RandMax)/#RandMax
                      zz = Round(rand*3*(4-ll), #PB_Round_Down)
                    EndIf
                    act_val = zz - MakeBestMove(rr, ll, zz-best_val)
                    MoveCount = MoveCount - 1
                    If act_val >= vv_cut
                      ProcedureReturn act_val
                    EndIf
                    If best_val < act_val
                      best_val = act_val
                      If rr = 1
                        I_Sel(0) = ii0
                        J_Sel(0) = jj0
                        I_Sel(1) = ii1
                        J_Sel(1) = jj1
                        NeedToRemove = #False
                      EndIf
                    EndIf
                  Else
                    ii3 = mm+3
                    jj3 = 0
                    While (Fld(ii3, jj3, rr) <> -1)
                      jj3 = jj3 + 1
                    Wend
                    For ii2 = 0 To 2
                      For jj2 = 0 To 7
                        If VirtualRemove(ii2, jj2, ii3, jj3, rr) > 0
                          MoveCount = MoveCount + 1
                          zz = 0
                          If rr = 1
                            rand = Random(#RandMax)/#RandMax
                            zz = Round(rand*6*(4-ll), #PB_Round_Down)
                          EndIf
                          act_val = zz - MakeBestMove(rr, ll, zz-best_val)
                          MoveCount = MoveCount - 1
                          If act_val >= vv_cut
                            ProcedureReturn act_val
                          EndIf
                          If best_val < act_val
                            best_val = act_val
                            If rr = 1
                              I_Sel(0) = ii0
                              J_Sel(0) = jj0
                              I_Sel(1) = ii1
                              J_Sel(1) = jj1
                              I_Sel(2) = ii2
                              J_Sel(2) = jj2
                              I_Sel(3) = ii3
                              J_Sel(3) = jj3
                              NeedToRemove = #True
                            EndIf
                          EndIf
                          Fld(ii2, jj2, rr) = Fld(ii3, jj3, rr)
                          Fld(ii3, jj3, rr) = -1
                        EndIf
                      Next jj2
                    Next ii2
                  EndIf
                EndIf
              Next jj1
            Next ii1
          EndIf
        Next jj0
      Next ii0
    Else
      For ii0 = 0 To 2
        For jj0 = 0 To 7
          If Fld(ii0, jj0, nn) = mm
            For dd = 0 To ((4-2*(jj0%2))-1)
              If dd = 0
                ii1 = ii0 : jj1 = (jj0+7)%8
              EndIf
              If dd = 1
                ii1 = ii0 : jj1 = (jj0+1)%8
              EndIf
              If dd = 2
                ii1 = ii0 - 1 : jj1 = jj0
              EndIf
              If dd = 3
                ii1 = ii0 + 1 : jj1 = jj0
              EndIf
              vv = MakeVirtualMove(ii0, jj0, ii1, jj1, rr)
              If (vv > 0)
                ;isvalid = #True
                If vv = 1
                  MoveCount = MoveCount + 1
                  zz = 0
                  If rr = 1
                    rand = Random(#RandMax)/#RandMax
                    zz = Round(rand*3*(4-ll), #PB_Round_Down)
                  EndIf
                  act_val = zz - MakeBestMove(rr, ll, zz-best_val)
                  MoveCount = MoveCount - 1
                  If act_val >= vv_cut
                    ProcedureReturn act_val
                  EndIf
                  If best_val < act_val
                    best_val = act_val
                    If rr = 1
                      I_Sel(0) = ii0
                      J_Sel(0) = jj0
                      I_Sel(1) = ii1
                      J_Sel(1) = jj1
                      NeedToRemove = #False
                    EndIf
                  EndIf
                Else
                  ii3 = mm+3
                  jj3 = 0
                  While (Fld(ii3, jj3, rr) <> -1)
                    jj3 = jj3 + 1
                  Wend
                  For ii2 = 0 To 2
                    For jj2 = 0 To 7
                      If (VirtualRemove(ii2, jj2, ii3, jj3, rr) > 0)
                        MoveCount = MoveCount + 1
                        zz = 0
                        If rr = 1
                          rand = Random(#RandMax)/#RandMax
                          zz = Round(rand*6*(4-ll), #PB_Round_Down)
                        EndIf
                        act_val = zz - MakeBestMove(rr, ll, zz-best_val)
                        MoveCount = MoveCount - 1
                        If act_val >= vv_cut
                          ProcedureReturn act_val
                        EndIf
                        If best_val < act_val
                          best_val = act_val
                          If rr = 1
                            I_Sel(0) = ii0
                            J_Sel(0) = jj0
                            I_Sel(1) = ii1
                            J_Sel(1) = jj1
                            I_Sel(2) = ii2
                            J_Sel(2) = jj2
                            I_Sel(3) = ii3
                            J_Sel(3) = jj3
                            NeedToRemove = #True
                          EndIf
                        EndIf
                        Fld(ii2, jj2, rr) = Fld(ii3, jj3, rr)
                        Fld(ii3, jj3, rr) = -1
                      EndIf
                    Next jj2
                  Next ii2
                EndIf
              EndIf
            Next dd
          EndIf
        Next jj0
      Next ii0
    EndIf
  EndIf
  If rr > 1
    ProcedureReturn best_val
  EndIf
  NeedToMove = 6
EndProcedure

Procedure.l Clicked(ii.l, jj.l)
  If IsOver
    ProcedureReturn 0
  EndIf
  If NeedToMove > 0
    ProcedureReturn 0
  EndIf
  If (Not IsPlayer((MoveCount+Start)%2))
    ProcedureReturn 0
  EndIf
  If NeedToMove = 0
    If MoveCount < 18
      If (ii <> (MoveCount+Start)%2+3)
        If ((MoveCount+Start)%2 = 0)
          MessageRequester("Spielinfo", "Nimm einen neuen weißen Stein von der linken Seite!")
        Else
          MessageRequester("Spielinfo", "Nimm einen neuen schwarzen Stein von der rechten Seite!")
        EndIf
        ProcedureReturn 0
      EndIf
      If (Fld((MoveCount+Start)%2+3, jj, 0) <> (MoveCount+Start)%2)
        If ((MoveCount+Start)%2 = 0)
          MessageRequester("Spielinfo", "Klicke auf einen weißen Stein auf der linken Seite!")
        Else
          MessageRequester("Spielinfo", "Klicke auf einen schwarzen Stein auf der rechten Seite!")
        EndIf
        ProcedureReturn 0
      EndIf
    Else
      If ((ii > 2) Or (Fld(ii, jj, 0) <> (MoveCount+Start)%2))
        If ((MoveCount+Start)%2 = 0)
          MessageRequester("Spielinfo", "Nimm einen weißen Stein vom Brett!")
        Else
          MessageRequester("Spielinfo", "Nimm einen schwarzen Stein vom Brett!")
        EndIf
        ProcedureReturn 0
      EndIf
    EndIf
    I_Sel(0) = ii
    J_Sel(0) = jj
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+3)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
      StopDrawing()
    EndIf
    NeedToMove = -1
    ProcedureReturn 0
  EndIf
  If NeedToMove = -1
    If ((ii = I_Sel(0)) And (jj = J_Sel(0)))
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+1)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
        StopDrawing()
      EndIf
      NeedToMove = 0
      ProcedureReturn 0
    EndIf
    If ((ii > 2) Or (Fld(ii, jj, 0) <> -1))
      MessageRequester("Spielinfo", "Du mußt deinen Stein auf einen freien Punkt des Spielbrettes legen!")
      ProcedureReturn 0
    EndIf
    If ((MoveCount >= 18) And (NumPieces((MoveCount+Start)%2,0) > 3) And (((jj = J_Sel(0)) And (jj%2 = 1)) Or (4-IAbs(4-(jj-J_Sel(0)+8)%8)+IAbs(ii-I_Sel(0)) > 1)))
      MessageRequester("Spielinfo", "Du mußt deinen Stein auf ein benachbartes Feld schieben!")
      ProcedureReturn 0
    EndIf
    I_Sel(1) = ii
    J_Sel(1) = jj
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(0), J_Sel(0)), GetGameY(I_Sel(0), J_Sel(0)))
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+3)),GetGameX(I_Sel(1), J_Sel(1)), GetGameY(I_Sel(1), J_Sel(1)))
      StopDrawing()
    EndIf
    Fld(I_Sel(1), J_Sel(1), 0) = Fld(I_Sel(0), J_Sel(0), 0)
    Fld(I_Sel(0), J_Sel(0), 0) = -1
    If IsMill(ii, jj, 0)
      If ((MoveCount+Start)%2 = 0)
        SetGadgetText(Msg, " Nimm einen schwarzen Stein!")
      Else
        SetGadgetText(Msg, " Nimm einen weißen Stein!")
      EndIf
      NeedToRemove = #True
      NeedToMove = -2
    Else
      NeedToRemove = #False
      NeedToMove = 4
    EndIf
    Fld(I_Sel(0), J_Sel(0), 0) = Fld(I_Sel(1), J_Sel(1), 0)
    Fld(I_Sel(1), J_Sel(1), 0) = -1
    ProcedureReturn 0
  EndIf
  If NeedToMove = -2
    If ((ii > 2) Or (Fld(ii, jj, 0) <> (MoveCount+Start+1)%2))
      If ((MoveCount+Start)%2 = 0)
        MessageRequester("Spielinfo", "Nimm einen schwarzen Stein vom Spielbrett!")
      Else
        MessageRequester("Spielinfo", "Nimm einen weißen Stein vom Spielbrett!")
      EndIf
      ProcedureReturn 0
    EndIf
    If Not CanRemove(ii, jj, 0)
      MessageRequester("Spielinfo", "Du mußt einen Stein von außerhalb einer Mühle wegnehmen!")
      ProcedureReturn 0
    EndIf
    I_Sel(2) = ii
    J_Sel(2) = jj
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(0), J_Sel(0), 0)+1)),GetGameX(I_Sel(1), J_Sel(1)), GetGameY(I_Sel(1), J_Sel(1)))
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+3)),GetGameX(I_Sel(2), J_Sel(2)), GetGameY(I_Sel(2), J_Sel(2)))
      StopDrawing()
    EndIf
    NeedToMove = -3
    ProcedureReturn 0
  EndIf
  If NeedToMove = -3
    If ((ii = I_Sel(2)) And (jj = J_Sel(2)))
      If StartDrawing(CanvasOutput(Spielbrett))
        DrawingMode(#PB_2DDrawing_AllChannels)
        DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+1)),GetGameX(I_Sel(2), J_Sel(2)), GetGameY(I_Sel(2), J_Sel(2)))
        StopDrawing()
      EndIf
      NeedToMove = -2
      ProcedureReturn 0
    EndIf
    If ((ii <> (MoveCount+Start)%2+3) Or ((Fld(ii, jj, 0) <> -1) And (jj <> J_Sel(0))))
      If ((MoveCount+Start)%2 = 0)
        MessageRequester("Spielinfo", "Lege diesen Stein auf ein freies Feld auf der linken Seite des Spielbrettes!")
      Else
        MessageRequester("Spielinfo", "Lege diesen Stein auf ein freies Feld auf der rechten Seite des Spielbrettes!")
      EndIf
      ProcedureReturn 0
    EndIf
    I_Sel(3) = ii
    J_Sel(3) = jj
    If StartDrawing(CanvasOutput(Spielbrett))
      DrawingMode(#PB_2DDrawing_AllChannels)
      DrawAlphaImage(ImageID(Pic(0)),GetGameX(I_Sel(2), J_Sel(2)), GetGameY(I_Sel(2), J_Sel(2)))
      DrawAlphaImage(ImageID(Pic(Fld(I_Sel(2), J_Sel(2), 0)+3)),GetGameX(I_Sel(3), J_Sel(3)), GetGameY(I_Sel(3), J_Sel(3)))
      StopDrawing()
    EndIf
    NeedToMove = 1
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l GetGameX(gx.l, gy.l)
  xw.l = 0
  If (gx = 0 And gy = 0)
    xw = 240
  ElseIf (gx = 0 And gy = 1)
    xw = 300
  ElseIf (gx = 0 And gy = 2)
    xw = 300
  ElseIf (gx = 0 And gy = 3)
    xw = 300
  ElseIf (gx = 0 And gy = 4)
    xw = 240
  ElseIf (gx = 0 And gy = 5)
    xw = 180
  ElseIf (gx = 0 And gy = 6)
    xw = 180
  ElseIf (gx = 0 And gy = 7)
    xw = 180
  ElseIf (gx = 1 And gy = 0)
    xw = 240
  ElseIf (gx = 1 And gy = 1)
    xw = 365
  ElseIf (gx = 1 And gy = 2)
    xw = 365
  ElseIf (gx = 1 And gy = 3)
    xw = 365
  ElseIf (gx = 1 And gy = 4)
    xw = 240
  ElseIf (gx = 1 And gy = 5)
    xw = 120
  ElseIf (gx = 1 And gy = 6)
    xw = 120
  ElseIf (gx = 1 And gy = 7)
    xw = 120
  ElseIf (gx = 2 And gy = 0)
    xw = 240
  ElseIf (gx = 2 And gy = 1)
    xw = 425
  ElseIf (gx = 2 And gy = 2)
    xw = 425
  ElseIf (gx = 2 And gy = 3)
    xw = 425
  ElseIf (gx = 2 And gy = 4)
    xw = 240
  ElseIf (gx = 2 And gy = 5)
    xw = 55
  ElseIf (gx = 2 And gy = 6)
    xw = 55
  ElseIf (gx = 2 And gy = 7)
    xw = 55
  EndIf
  For a.l = 0 To 8
    If (gx = 3 And gy = a)
      xw = 5
    EndIf
  Next a
  For b.l = 0 To 8
    If (gx = 4 And gy = b)
      xw = 475
    EndIf
  Next b
  ProcedureReturn xw
EndProcedure

Procedure.l GetGameY(gx.l, gy.l)
  yw.l = 0
  If (gx = 0 And gy = 0)
    yw = 140
  ElseIf (gx = 0 And gy = 1)
    yw = 140
  ElseIf (gx = 0 And gy = 2)
    yw = 190
  ElseIf (gx = 0 And gy = 3)
    yw = 240
  ElseIf (gx = 0 And gy = 4)
    yw = 240
  ElseIf (gx = 0 And gy = 5)
    yw = 240
  ElseIf (gx = 0 And gy = 6)
    yw = 190
  ElseIf (gx = 0 And gy = 7)
    yw = 140
  ElseIf (gx = 1 And gy = 0)
    yw = 90
  ElseIf (gx = 1 And gy = 1)
    yw = 90
  ElseIf (gx = 1 And gy = 2)
    yw = 190
  ElseIf (gx = 1 And gy = 3)
    yw = 290
  ElseIf (gx = 1 And gy = 4)
    yw = 290
  ElseIf (gx = 1 And gy = 5)
    yw = 290
  ElseIf (gx = 1 And gy = 6)
    yw = 190
  ElseIf (gx = 1 And gy = 7)
    yw = 90
  ElseIf (gx = 2 And gy = 0)
    yw = 40
  ElseIf (gx = 2 And gy = 1)
    yw = 40
  ElseIf (gx = 2 And gy = 2)
    yw = 190
  ElseIf (gx = 2 And gy = 3)
    yw = 340
  ElseIf (gx = 2 And gy = 4)
    yw = 340
  ElseIf (gx = 2 And gy = 5)
    yw = 340
  ElseIf (gx = 2 And gy = 6)
    yw = 190
  ElseIf (gx = 2 And gy = 7)
    yw = 40
  EndIf
  tw.l = 10
  For a.l = 0 To 8
    If (gx = 3 And gy = a)
      yw = tw
    EndIf
    tw = tw + 45
  Next a
  tw.l = 10
  For b.l = 0 To 8
    If (gx = 4 And gy = b)
      yw = tw
    EndIf
    tw = tw + 45
  Next b
  ProcedureReturn yw
EndProcedure
  
Procedure RefreshScreen()
  ;Bilderupdate!!!
  DrawBoard()
  SetGadgetText(Moves, MoveString(MoveCount))
  If ((MoveCount+Start)%2 = 0)
    SetGadgetText(Msg, " Weiß am Zug.")
  Else
    SetGadgetText(Msg, " Schwarz am Zug.")
  EndIf
EndProcedure

Procedure RefreshBoard()
  If StartDrawing(CanvasOutput(Spielbrett))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawAlphaImage(ImageID(Pic(5)), 0, 0)
    StopDrawing()
  EndIf
EndProcedure

Procedure DrawBoard()
  If StartDrawing(CanvasOutput(Spielbrett))
    DrawingMode(#PB_2DDrawing_AllChannels)
    DrawAlphaImage(ImageID(Pic(5)), 0, 0)
    ;linker Rand
    For i = 0 To 8
      DrawAlphaImage(ImageID(Pic(1)),GetGameX(3,i),GetGameY(3,i))
    Next i
    ;Mitte
    h1 = 55
    For i = 0 To 6
      For j = 0 To 6
        If (((i = 3) Or (j = 3) Or (i = j) Or (i = 6-j)) And ((i <> 3) Or (j <> 3)))
          If ((j = 3) And (i < 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(2-i,0),GetGameY(2-i,0))
          EndIf
          If ((j = 6-i) And (i < 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(2-i,1),GetGameY(2-i,1))
          EndIf
          If ((i = 3) And (j > 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(j-4,2),GetGameY(j-4,2))
          EndIf
          If ((j = i) And (i > 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(i-4,3),GetGameY(i-4,3))
          EndIf
          If ((j = 3) And (i > 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(i-4,4),GetGameY(i-4,4))
          EndIf
          If ((j = 6-i) And (i > 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(i-4,5),GetGameY(i-4,5))
          EndIf
          If ((i = 3) And (j < 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(2-j,6),GetGameY(2-j,6))
          EndIf
          If ((j = i) And (i < 3))
            DrawAlphaImage(ImageID(Pic(0)),GetGameX(2-i,7),GetGameY(2-i,7))
          EndIf
        Else
          ;???
        EndIf
      Next j
    Next i
    ;rechter Rand
    For i = 0 To 8
      DrawAlphaImage(ImageID(Pic(2)),GetGameX(4,i),GetGameY(4,i))
    Next i
    StopDrawing()
  EndIf
EndProcedure

Procedure OpenMuehleGUI(x = 0, y = 0, width = 760, height = 450)
  MuehleGUI = OpenWindow(#PB_Any, x, y, width, height, "Mein tolles Mühlespiel", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  SetWindowColor(MuehleGUI, RGB(133,169,111))
  Frame_0 = FrameGadget(#PB_Any, 550, 0, 200, 40, "")
  White1 = OptionGadget(#PB_Any, 560, 10, 180, 25, "Weiß: Spieler")
  White2 = OptionGadget(#PB_Any, 560, 50, 170, 25, "Weiß: Computer")
  Frame_1 = FrameGadget(#PB_Any, 550, 40, 200, 70, "")
  Text_0 = TextGadget(#PB_Any, 560, 80, 60, 25, "Level: ")
  WhiteLevel1 = OptionGadget(#PB_Any, 630, 80, 30, 25, "1")
  WhiteLevel2 = OptionGadget(#PB_Any, 670, 80, 30, 25, "2")
  WhiteLevel3 = OptionGadget(#PB_Any, 710, 80, 30, 25, "3")
  Frame_2 = FrameGadget(#PB_Any, 550, 110, 200, 40, "")
  Black1 = OptionGadget(#PB_Any, 560, 120, 180, 25, "Schwarz: Spieler")
  Black2 = OptionGadget(#PB_Any, 560, 160, 180, 25, "Schwarz: Computer")
  Frame_3 = FrameGadget(#PB_Any, 550, 150, 200, 70, "")
  Text_1 = TextGadget(#PB_Any, 560, 190, 60, 25, "Level: ")
  BlackLevel1 = OptionGadget(#PB_Any, 630, 190, 30, 25, "1")
  BlackLevel2 = OptionGadget(#PB_Any, 670, 190, 30, 25, "2")
  BlackLevel3 = OptionGadget(#PB_Any, 710, 190, 30, 25, "3")
  Frame_4 = FrameGadget(#PB_Any, 550, 220, 200, 60, "")
  Start1 = OptionGadget(#PB_Any, 560, 230, 170, 25, "Weiß beginnt")
  Start2 = OptionGadget(#PB_Any, 560, 250, 170, 25, "Schwarz beginnt")
  Frame_5 = FrameGadget(#PB_Any, 550, 280, 200, 60, "Spielinfo:")
  Msg = StringGadget(#PB_Any, 560, 300, 180, 25, " Weiß am Zug.", #PB_String_ReadOnly)
  NewButton = ButtonGadget(#PB_Any, 550, 350, 200, 25, "Neues Spiel")
  DBack = ButtonGadget(#PB_Any, 550, 390, 40, 25, "<<")
  OBack = ButtonGadget(#PB_Any, 590, 390, 40, 25, "<")
  Moves = StringGadget(#PB_Any, 630, 390, 40, 30, "0", #PB_String_Numeric | #PB_String_ReadOnly)
  OForward = ButtonGadget(#PB_Any, 670, 390, 40, 25, ">")
  DForward = ButtonGadget(#PB_Any, 710, 390, 40, 25, ">>")
  Spielbrett = CanvasGadget(#PB_Any, 10, 10, 520, 420, #PB_Canvas_Border)
EndProcedure

Procedure BoardEventHandler(x, y, EventType)
  If EventType = #PB_EventType_LeftClick
    ;linker Rand
    h.l = 10
    For t.l = 0 To 8
      If ((x > 5 And x < 45) And (y > h And y < (h+40)))
        Clicked(3, t)
      EndIf
      h = h + 45
    Next t
    ;Mitte (Spielfeld)
    If ((x > 55 And x < 95) And (y > 40 And y < 80))
      Clicked(2, 7)
    EndIf
    If ((x > 240 And x < 280) And (y > 40 And y < 80))
      Clicked(2, 0)
    EndIf
    If ((x > 425 And x < 465) And (y > 40 And y < 80))
      Clicked(2, 1)
    EndIf
    If ((x > 120 And x < 160) And (y > 90 And y < 130))
      Clicked(1, 7)
    EndIf
    If ((x > 240 And x < 280) And (y > 90 And y < 130))
      Clicked(1, 0)
    EndIf
    If ((x > 365 And x < 405) And (y > 90 And y < 130))
      Clicked(1, 1)
    EndIf
    If ((x > 180 And x < 220) And (y > 140 And y < 180))
      Clicked(0, 7)
    EndIf
    If ((x > 240 And x < 280) And (y > 140 And y < 180))
      Clicked(0, 0)
    EndIf
    If ((x > 300 And x < 340) And (y > 140 And y < 180))
      Clicked(0, 1)
    EndIf
    If ((x > 55 And x < 95) And (y > 190 And y < 230))
      Clicked(2, 6)
    EndIf
    If ((x > 120 And x < 160) And (y > 190 And y < 230))
      Clicked(1, 6)
    EndIf
    If ((x > 180 And x < 220) And (y > 190 And y < 230))
      Clicked(0, 6)
    EndIf
    If ((x > 300 And x < 340) And (y > 190 And y < 230))
      Clicked(0, 2)
    EndIf
    If ((x > 365 And x < 405) And (y > 190 And y < 230))
      Clicked(1, 2)
    EndIf
    If ((x > 425 And x < 465) And (y > 190 And y < 230))
      Clicked(2, 2)
    EndIf
    If ((x > 180 And x < 220) And (y > 240 And y < 280))
      Clicked(0, 5)
    EndIf
    If ((x > 240 And x < 280) And (y > 240 And y < 280))
      Clicked(0, 4)
    EndIf
    If ((x > 300 And x < 340) And (y > 240 And y < 280))
      Clicked(0, 3)
    EndIf
    If ((x > 120 And x < 160) And (y > 290 And y < 330))
      Clicked(1, 5)
    EndIf
    If ((x > 240 And x < 280) And (y > 290 And y < 330))
      Clicked(1, 4)
    EndIf
    If ((x > 365 And x < 405) And (y > 290 And y < 330))
      Clicked(1, 3)
    EndIf
    If ((x > 55 And x < 95) And (y > 340 And y < 380))
      Clicked(2, 5)
    EndIf
    If ((x > 240 And x < 280) And (y > 340 And y < 380))
      Clicked(2, 4)
    EndIf
    If ((x > 425 And x < 465) And (y > 340 And y < 380))
      Clicked(2, 3)
    EndIf
    ;rechter Rand
    h.l = 10
    For t.l = 0 To 8
      If ((x > 475 And x < 515) And (y > h And y < (h+40)))
        Clicked(4, t)
      EndIf
      h = h + 45
    Next t
  EndIf
EndProcedure

Procedure MuehleGUI_Events(event)
  Select event
    Case #PB_Event_CloseWindow
      ProcedureReturn #False

    Case #PB_Event_Menu
      Select EventMenu()
      EndSelect
      
    Case #PB_Event_Timer
      Select EventTimer()
          Case 456
            Timer()
      EndSelect
    Case #PB_Event_Gadget
      Select EventGadget()
        Case Spielbrett
          X = GetGadgetAttribute(Spielbrett, #PB_Canvas_MouseX)
          Y = GetGadgetAttribute(Spielbrett, #PB_Canvas_MouseY)
          Type = EventType()
          Select EventType()
            Case #PB_EventType_LeftClick
              BoardEventHandler(X,Y,Type)
          EndSelect
        Case White1
          SetOption(0,1)
        Case White2
          SetOption(0,0)
        Case WhiteLevel1
          SetLevel(0,1)
        Case WhiteLevel2
          SetLevel(0,2)
        Case WhiteLevel3
          SetLevel(0,2)
        Case Black1
          SetOption(1,1)
        Case Black2
          SetOption(1,0)
        Case BlackLevel1
          SetLevel(1,1)
        Case BlackLevel2
          SetLevel(1,2)
        Case BlackLevel3
          SetLevel(1,2)
        Case Start1
          SetOption(2,1)
        Case Start2
          SetOption(2,0)
        Case NewButton
          Init()
          GetStartOptions()
        Case DBack
          Back() : Back()
        Case OBack
          Back()
        Case DForward
          Replay() : Replay()
        Case OForward
          Replay()
      EndSelect
  EndSelect
  ProcedureReturn #True
EndProcedure

Procedure SetStartOptions()
  SetGadgetState(White1, 1)
  SetGadgetState(White2, 0)
  SetGadgetState(WhiteLevel1, 1)
  SetGadgetState(WhiteLevel2, 0)
  SetGadgetState(WhiteLevel3, 0)
  SetGadgetState(Black1, 0)
  SetGadgetState(Black2, 1)
  SetGadgetState(BlackLevel1, 0)
  SetGadgetState(BlackLevel2, 1)
  SetGadgetState(BlackLevel3, 0)
  SetGadgetState(Start1, 1)
  SetGadgetState(Start2, 0)
EndProcedure

Procedure GetStartOptions()
  If GetGadgetState(White1)
    SetOption(0,1)
  ElseIf GetGadgetState(White2)
    SetOption(0,0)
  EndIf
  If GetGadgetState(WhiteLevel1)
    SetLevel(0,1)
  ElseIf GetGadgetState(WhiteLevel2)
    SetLevel(0,2)
  ElseIf GetGadgetState(WhiteLevel3)
    SetLevel(0,2)
  EndIf
  If GetGadgetState(Black1)
    SetOption(1,1)
  ElseIf  GetGadgetState(Black2)
    SetOption(1,0)
  EndIf
  If GetGadgetState(BlackLevel1)
    SetLevel(1,1)
  ElseIf GetGadgetState(BlackLevel2)
    SetLevel(1,2)
  ElseIf GetGadgetState(BlackLevel3)
    SetLevel(1,2)
  EndIf
  If GetGadgetState(Start1)
    SetOption(2,1)
  ElseIf GetGadgetState(Start2)
    SetOption(2,0)
  EndIf
EndProcedure

OpenMuehleGUI()
SetStartOptions()
Init()
GetStartOptions()
AddWindowTimer(MuehleGUI, 456, 200)
Repeat
  event = WindowEvent()
  ende = MuehleGUI_Events(event)
Until Not Ende

DataSection
  mill0:
  IncludeBinary "mill0.png"
  mill1:
  IncludeBinary "mill1.png"
  mill2:
  IncludeBinary "mill2.png"
  mill3:
  IncludeBinary "mill3.png"
  mill4:
  IncludeBinary "mill4.png"
  millbg:
  IncludeBinary "millbg.png"
EndDataSection
; IDE Options = PureBasic 5.60 (Linux - x64)
; CursorPosition = 1265
; FirstLine = 1263
; Folding = -----
; EnableXP
; Watchlist = MakeBestMove()>mm;MakeVirtualMove()>rr
; EnableUnicode